	SECTION	QXL

	include	dev1_asm_incl_keys_err

	xref	rt_fp
**************************************************************************************
; some macros
; macro to define sbasic keywords where name & name of routine are the same

kwrd	macro	name
;	 xref	 [name]		; makes basic keyword data structure
	dc.w	[name]-*
	dc.b	[.len(name)]
	dc.b	'[name]'
	endm

XJSR	macro	name
	xref	[name]		; - makes external jump
	JSR	[name]
	ENDM
************************************************************************************
; start of code - jst link in Sbasic fns

start	LEA	procs,A1
	MOVE.W	$110,A2
	JMP	(A2)
; sbasic procedures
procs	DC.W	0,0,4
	kwrd	QXL_SET
	kwrd	READ_FILE
	kwrd	GET_OFFSET
	DC.L	 0,0

**************************************************************************************
; some constants

fat	DC.L	0		; pointer to memory for QL fat
chid	DC.L	0		; channel ID for CRDOM drive
dev_nrsec DC.L	0		; nbr of 512 byte sectors per QLD cluster
dev_clsiz DC.L	0		; nbr of bytes per QLD cluster
offset	DC.L	0		; offset to start of QXL file
fatoff	EQU	$40
header	EQU	$40


***************************************************************
*
* QXL_SET :  fat = QXL_SET #chan%
*
*
* this reads in the entire (!) FAT for the qxl drive
*
* chan% is the channel opened to the cdr drive: cdrx_*d8d
***************************************************************

errbp	MOVEQ	#-15,d0
rel_out	RTS
qxl_set
	XJSR	chan_num		; get channel ID into A0
	BNE	qxl_err1		; oops
	LEA	chid(PC),A4
	MOVE.L	A0,(A4)		; channel ID
	MOVE.L	A0,A4
	MOVE.L	#2048,D0
	XJSR	gu_achp		; get some mem now
	BNE	qxl_err1		; ooops
	EXG	A0,A4
test	MOVE.L	offset(PC),D1
	MOVEQ	#-1,D3
	MOVEQ	#$42,D0
	TRAP	#3		; reposition at beginning of file
	MOVE.L	#2048,D2		; get 2048 bytes
	TST.L	D0
	BNE	qxl_err1
	MOVE.L	A4,A1		; into here...
	MOVEQ	#3,D0
	TRAP	#3		; now...
	TST.L	D0		; ok?
	BNE	qxl_err1		; oops->...
	CMP.W	D2,D1
	BNE.S	errbp
	CLR.L	D7
	MOVE.W	$22(A4),D7	; number of sectors per cluster in QLD
	MOVE.W	D7,D5
	SUBQ.W	#1,D5
	LEA	dev_nrsec(PC),A2
	MOVE.L	D5,(A2)+		; d5 = nbr of sectors / cluster -1
	MULU	#512,D7		; number of bytes per cluster
	MOVE.L	D7,(A2)+		; store it
	MOVE.W	$2A(A4),D0	; number of clusters in fat
	LSL.L	#1,D0		; fat = 2 bytes per cluster
	ADD.L	#$44,D0		; total number of bytes needed ($40...
	MOVE.L	D0,D2		; ... for header + 4 bytes for RECHP...
	ADD.L	D7,D0		;  ... link, rest as 1 cluster buffer)
	EXG	A4,A0		; A4 = channel ID, A0 = memory
	XJSR	gu_rchp		; release OLD memory
	XJSR	gu_achp		; and get my memory
	BNE.S	qxl_err		; oops
	LEA	$E0(A6),A1	; pointer to our link
	MOVE.W	$D2,A2
	JSR	(A2)		; link this into heap
	ADDQ.L	#4,A0		; cut out linkage area, for RECHP...

	LEA	fat(PC),A3
	MOVE.L	A0,(A3)		; keep pointer to my memory

	EXG	A4,A0		; A0 = channel ID, A4 = memory
rdlp	MOVE.L	offset(PC),D1
	MOVEQ	#$42,D0
	TRAP	#3		; reposition at beginning of file
	TST.L	D0		; ok?
	BNE.S	qxl_err1		; no->....!
	MOVE.L   A4,A1	         ; pointer to space for header & FAT
	MOVE.L	D2,D4		; nbr of bytes to get
do_loop	CMP.L	#$8000,D4
	BLE.S	end
	SUB.L	#$7FFE,D4
	MOVE.L	#$7FFE,D2
iloop	MOVEQ	#3,D0
	TRAP	#3
	TST.L	D0
	BEQ.S	do_loop
	CMP.L	#-1,D0
	BNE.S	qxl_err1
	SUB.W	D1,D2
	BRA.S	iloop
end	MOVE.L	D4,D2
	MOVEQ	#3,D0
	TRAP	#3
	TST.L	D0
	      
	BNE.S	qxl_err1		; oops
	MOVE.L	A4,D2
	JMP	rt_fp		; return address now
qxl_err	RTS
qxl_err2	MOVEQ	#-15,D0
qxl_err1	MOVE.L	A4,A0
	XJSR	gu_rchp
	RTS

*****************************************************************
*
*
*        file = READ_FILE  initial cluster,length
*
*        read an entire file into memory !
*
*	file= address of file in memory, or 0 if error
*
*
*****************************************************************


read_file MOVE.L	fat(PC),D5
	BEQ	errbp		; what, no FAT?
	MOVE.W	$118,A2
	JSR	(A2)
	TST.L	D0
	BNE.S	qxl_err
	SUBQ.W	#2,D3
	BNE	errbp
	ADDQ.L	#8,$58(A6)
	MOVE.L	(A6,A1.L),D6	; initial cluster
	MOVE.L	4(A6,A1.L),D7	; length of this file (incl. header)
	MOVE.L	D7,D0
	ADD.L	#2053,D0		; just to be on the safe side
	BCLR	#0,D0
	ADD.L	dev_clsiz(PC),D0	;  "   "	" "  " " " " " "
	XJSR	gu_achp		; get mem now
	BNE.S	rf_out		; oops!
	LEA	$E0(A6),A1	; pointer to our link
	MOVE.W	$D2,A2
	JSR	(A2)		; link this into heap
	ADDQ.L	#4,A0		; cut out linkage area, so that RECHP..
	MOVE.L	A0,A5		; keep mem pointer
	MOVE.L	chid(PC),A0	; point to my channel ID
	MOVE.L	D5,A4		; point to FAT
	MOVE.L	A5,A1		; point to this now
readloop	BSR.S	readclust 	; read cluster into (A1) now
	BNE.S	rf_out		; ooops
	TST.W	D6		; any more clusters to get?
	BEQ.S	rf_end		; no, finished->...
	CMP.L	#-1,D6
	BEQ.S	fat_error
	AND.L	#$FFFF,D1
	SUB.L	D1,D7
	BLE.S	rf_end		; don't get more than file length, anyway!
	BRA.S	readloop
rf_out	RTS
rf_end	MOVE.L	A5,D2		; return memory
	JMP	rt_fp
; there was an error in the fat - it happens!
fat_error MOVE.L	A5,A0		; release memory
	XJSR	gu_rchp		; now
	CLR.L	D2		; return 0
	JMP	rt_fp		;
**********************************************************
;
; readclust subroutine
; read the wished QXL cluster

; some assumptions:
; a "qxl" cluster is the cluster ("allocation unit") used by the QXL.WIN file
;
; a 'cdr' doesn't really have clusters, just sectors
;
; a "qxl" cluster is made up of x sectors of 512 bytes.

; to read a "qxl" cluster, you do the following:
;  0  position cdr to start of cluster (QXL cluster nbr * nbr of bytes in
;     a cluster + possible offset)
;  1  D2 = nbr of bytes in 1 qxl cluster
;  2  read 2048 bytes from CDROM
;  3  if got: 4, else 2
;  4  deduct 2048 from D2
;  5  if 0 or less: 6, else 2
;  6  finished

rcregs	REG	D2-D3/A0/A2/A4

; this reads one QLD cluster into the memory pointed to by A1
; on entry			exit
;
; A0 = CDROM channel ID		stet
; A1 = memory for lcuster		updated
; A4 = FAT			stet
; D1 = ????			nbr of bytes got
; D6.L = cluster to be read		NEXT corresponding cluster (or 0)
; for now, we presume 1 QLD cluster = 1 Cd cluster, in length
;
; the cdrx_d8d file needs to have the file positon in BYTES; not
; 2048 sector numbers, which is quite handy
readclust MOVEM.L	rcregs,-(A7)
	MOVE.L	dev_clsiz(PC),D1	; number of bytes per QXL cluster
	MOVE.L	D1,D2		; we need to read that much
	MULU	D6,D1		; cl. nbr * bytes per clust= clust position in QXL file
	ADD.L	offset(PC),D1	; offset to start of QXL file
	MOVEQ	#-1,D3
	MOVEQ	#$42,D0
	TRAP	#3		; reposition here
	TST.L	D0		; ok?
	BNE.S	rc_out		; what?
lo	MOVEQ	#3,D0		; now get D2 bytes
	TRAP	#3
	TST.L	D0		; ok?
	BEQ.S	getnentry 	; yes->...
	CMP.L	#-1,D0		; no, was call incomplete?
	BNE.S	rc_out		; no, another error->...
	SUB.W	D1,D2		; incomplete, do again->...
	BRA.S	lo
; now calculate the next fat cluster
getnentry ADD.L	D6,D6		; FAT entry  = 1 word
	ADD.L	#$40,D6		; + fat header offset
	MOVE.W	(A4,D6.L),D0	; new FAT entry for this file
	MOVE.L	D0,D6		; make sure upper word is 0
	MOVEQ	#0,D0		;
rc_out	MOVEM.L	(A7)+,rcregs
p_out	RTS

***************************************************************************
*
*	offset=GET_OFFSET #chan%[,start]
*
*
* this tries to find a QXLWIN file in $100 "sectors" of the cdr
*
* it returns the offset, of:
* -1 no offet founnd in 256 sectors
* -2 probel when getting data from file
*
***************************************************************************


get_offset MOVEQ	#0,D7
	XJSR	chan_num		; get channel ID
	BNE.S	p_out		; oops
	MOVE.L	A0,A4
	CMP.L	A5,A3
	BEQ.S	no_param
	MOVE.W	$118,A2
	JSR	(A2)
	TST.L	D0
	BNE.S	p_out
	ADDQ.L	#4,$58(A6)
	MOVE.L	(A6,A1.L),D7	; start
no_param	MOVE.L	#2048,D0
	XJSR	gu_achp		; get some memory
	BNE.S	p_out
	EXG	A0,A4
	MOVEQ	#-1,D3
	MOVE.L	#2048,D2		; nbr of bytes to get each time
	MOVE.L	D7,D6
	ADD.L	#$100,D7
loop	MOVE.L	A4,A1
	MOVE.L	D6,D1
	LSL.L	#8,D1		;
	LSL.L	#3,D1		; D1=D1*2048 this should be taken out of the loop
	MOVEQ	#$42,D0
	TRAP	#3		; reposition here
	TST.L	D0		; ok?
	BNE.S	no_off2		; no, so pretend no offset found->...
lo2	MOVEQ	#3,D0		; now get D2 bytes
	TRAP	#3
	TST.L	D0		; ok?
	BEQ.S	got		; yes->...
	CMP.L	#-1,D0		; no, test whether error = incomplete
	BNE.S	no_off2		; no, so leave->...
	SUB.W	D1,D2		; yes, try again
	BRA.S	lo2
got	CMP.L	#'QLWA',(A4)	; is this the QXL Win file?
	BEQ.S	found_it		; yes!->...
	ADDQ.L	#1,D6
	CMP.L	D6,D7
	BNE.S	loop
no_off	MOVEQ	#-1,D6		; show no offset found!
	BRA.S	common
found_it	LSL.L	#8,D6
	LSL.L	#3,D6
common	LEA	offset(PC),A0
	MOVE.L	D6,(A0)		; store offset
	MOVE.L	A4,A0
	XJSR	gu_rchp		; release mem
	MOVE.L	D6,D2		; return number as float
	JMP	rt_fp
no_off2	MOVEQ	#-2,D6
	BRA.S	common

	end
